
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <semaphore.h>
#include "curses.h"
#include "rwlock.h"




void* reader(void* threadParam)
{
   while (1)
   {
      rwlock_acquire_readlock();
      // do some reading
      Sleep(5000);
      // done reading
      rwlock_release_readlock();
   }
   return NULL;
}//reader()




void* writer(void* threadParam)
{
   while (1)
   {
      rwlock_acquire_writelock();
      // do some reading
      Sleep(5000);
      // done reading
      rwlock_release_writelock();
   }
   return NULL;
}//writer()












#include "roomDisplay.h"  // this code maintains the "console gui"


int main(int argc, char *argv[])
{
   pthread_t tid;


   (void) initscr();  /* initialize the curses library */
   (void) cbreak();   /* take input chars one at a time, don't wait for \n */
   (void) noecho();   /* don't echo input */


   rwlock_init();


   // initialize the array of customers to NULL pointers
   for (int i = 0; i < CUSTOMERS; i++)
      customers[i] = NULL;

   // Create the thread that updates the console window.
   pthread_create(&tid, NULL, roomDisplay, NULL);

   srand(time(NULL));  // seed the random number generator with current time

   while(1) // create one customer thread for each input character
   {
      // read a single input character (in raw mode) from the console
      getch();

      // create a customer_t struct for this thread
      newCustomer = (customer_t*)malloc(sizeof(customer_t));
      // give this customer a number
      //itoa(customerID++, newCustomer->id, 10);
      sprintf(newCustomer->id, "%d", customerID++);
      // give this customer an amount of time for dining
      newCustomer->time = 5+(rand()%20);  // between 5 and 25 seconds
      // put this customer in the entry state
      newCustomer->state = 0;

      // Create a customer thread that will dine for a random time.
      pthread_create(&tid, NULL, customer, (void*)newCustomer);
   }

   return 0;
}//main()
